function [temp_coefs, high_energy_areas] = prolonged_spikes(file,timebin,output, dat)

file
timebin
output
dat

percent = 45/100;
level_depth = 8;
start_date = datenum(dat);  %'2004-09-09 00:00:00');

%set threshold given timebin
threshold = 60*(timebin/10)

%c = cumsum(longs);
% length of time series
%file ='../wash_2004-09-09to2006-09-01.600s.csv'
[U F1] = textread(file, '%s %d', 'headerlines', 1);
len = length(F1);


[coefs,longs] = wavedec(F1',12,'haar');
% Expand discrete wavelet coefficients for plot.
% Levels 1 to 5 correspond to scales 2, 4, 8, 16 and 32.
cfd = zeros(12,len);
for k = 1:12
    d = detcoef(coefs,longs,k);
    d = d(ones(1,2^k),:);
    cfd(k,:) = wkeep(d(:)',len);
end

cfd = cfd(:);
I = find(abs(cfd)<sqrt(eps));
cfd(I)=zeros(size(I));
cfd = reshape(cfd,12,len);

%T = flipud(wcodemat(cfd, 64, 'row'));
T = flipud(abs(cfd));

% rescale the matrix 
%for i=1:size(T, 1)
%    T(i, :) = T(i, :) * (sqrt(2)^(13-i));
%end

%max_c = max(T(1, :)); %% because we want the black areas only
max_c = max(max(T, [], 2));

t_t = cell(level_depth, 1);
f_t = cell(level_depth, 1);
f_l = cell(level_depth, 1);

for j=1:level_depth
    j
    max_c = max(T(j, :));
    times = [];
    final_times = [];
    final_levels = [];


    start_t = -1;
    end_t = -1;
    for i=1:size(T, 2)

        if (T(j, i) >= (max_c-percent*max_c))
            if start_t == -1
                start_t = i;
            else
                end_t = i;
            end
        else
            if start_t ~= -1
                times(end+1, :) = [start_t end_t];
                % check whether the interval is contained in a previously
                % discovered interval
                flag = 0;
                for k=1:j-1
                    %display where
                    %k
                    temp = t_t{k};
                    for u=1:size(temp, 1)
                        %u
                        s = temp(u, 1);
                        e = temp(u, 2);
                        if start_t >= s && end_t <= e
                            % the interval has already been checked..no need to
                            % check again
                            flag = 1;
                            break;
                        end
                    end
                    if flag == 1
                        break;
                    end
                end

                %flag
                if flag == 0
                    [s_start, s_end, s_level] = find_tornado([start_t end_t], j+1, T, max_c, [start_t end_t]);
                    final_times(end+1, :) = [s_start, s_end];
		    final_times
                    final_levels(end+1, :) = 12 - s_level +1 ;
                else
		    display 'already discovered interval'
		    times
		end
                start_t = -1;
                end_t = -1;
            end
        end
    end

    t_t{j} = times;
    f_t{j} = final_times;
    f_l{j} = final_levels;
   
end

display 'looking into suspect times'
figure;
U1 = [];
for i=1:len
   U1(i) = i;
end
plot(U1,F1);
hold on;

% now fine tune the search within the found windows...
output_times = zeros(size(f_t, 1), 2);
fid = fopen([output 'prolonged_spike_suspect_times.txt'], 'wt');
for i = 1:size(f_t, 1)
    % check if it is non-empty
    temp = f_t{i};
    if length(temp) ~= 0
	%NOTE->ADDED
	for k = 1:size(temp,1)
        	t1 = temp(k, 1);
        	t2 = temp(k, 2);
        
        	start_t = -1;
        	end_t = -1;
        	times = [];
        	for j=t1:t2
            		if F1(j, 1) >= threshold
                	% it is part of a prolonged spike
                		if start_t == -1
                    			start_t = j;
		    			%NOTE->ADDED
	   	    			end_t = j;
                		else
                    			end_t = j;
                		end
            		else
                		if start_t ~= -1
                    			times(end+1, :) = [start_t end_t];
                    			start_t = -1;
                    			end_t = -1;
                		end
            		end
        	end
        	if start_t ~=-1 && end_t ~= -1
            		times(end+1, :) = [start_t end_t];
        	end
        	times
        
        	for j=1:size(times, 1) 
            		d1 = datestr(((times(j, 1)-1)*timebin/(24*3600))+start_date);
            		d2 = datestr((times(j, 2)*timebin/(24*3600))+start_date);
            		fprintf(fid,'%s\t%s\n', d1, d2);
			
					scatter(U1(times(j,1):times(j,2)),threshold*ones(times(j,2)-times(j,1)+1,1));
            		hold on;
        	end
	end
    end    
end

print('-djpeg', [output 'selected-spikes.jpg']);
fclose(fid);
quit

% for i = 1:size(f_t, 1)
%     % check if it is non-empty
%     temp = f_t{i};
%     if length(temp) ~= 0
%         t1 = temp(1, 1)
%         t2 = temp(1, 2)
%         d1 = datestr((t1*600/(24*3600))+start_date)
%         d2 = datestr((t2*600/(24*3600))+start_date)
%         fprintf(fid,'%s\t%s\n', d1, d2);
%     end    
% end
% 
% fclose(fid);
%save 'prolonged_spike_suspect_times.txt' output_times -ASCII;

% now this will be a script
% now check each non-empty f_t (write this to file)
% the script creates the SQL queries to be run on datapository
% scp the update-source files to this machine
% write another matlab function
% read the update - source file and time_period
% check which ip/as is very frequent in the time_period
% output them as culprits



%
%     % all detail coefficients
%     temp_coefs = T(1, :)
%     max_coeff = max(temp_coefs)
%
%     high_energy_areas = [];
%     for j=1:longs(i)
%         if(temp_coefs(j) >= (max_coeff-percent*max_coeff))
%             high_energy_areas(end+1) = j;
%         end
%     end
%     high_energy_areas
%     l  =length(high_energy_areas)
%
%     times = [];
%     window = len/longs(i);
%     for j=1:length(high_energy_areas)
%         temp = window*(high_energy_areas(j)-1)+1
%         times(end+1, :) = [temp window*high_energy_areas(j)];
%     end
%
%     times
% end
%
%
% for i=1:size(times, 1)
%     startt = times(i, 1);
%     endt = times(i, 2);
%
%     %% now check whether we get high energy in this time period
%     %% basically find a touchdown tornado:
%     %% high energy in coarser scales and low energy in lower scales
%     %%
%     %% high to low
%     for j=3:3%length(longs)-2
%         % find which indexes fall in the time period
%         % check if these indexes are high energy areas
%         % if atleast one of the indexes are high energy
%         % 	then continue going to finer scales
%         % o.w. break and report the smallest? (or the largest?) time periods
%         index = [];
%         window = len/longs(j);
%         i1 = ceil(startt/window);
%         i2 = ceil(endt/window);
%
%         index = [i1:i2];
%         temp_coefs = coefs(c(j-1)+1:c(j));
%         max_coeff = max(temp_coefs)
%
%         high_energy = zeros(length(index), 1);
%         count = 1
%         for k=i1:i2
%             if(temp_coefs(k) >= (max_coeff-percent*max_coeff))
%                 high_energy(count) = 1;
%             end
%             count = count +1;
%         end
%         high_energy
%         l  =length(high_energy)
%     end
% end
